orte/mca/rmgr/rmgr.h File Reference.TH "orte/mca/rmgr/rmgr.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/rmgr/rmgr.h \- The Open RTE Resource Manager (RMGR) Subsystem. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/orte_constants.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'mca/gpr/gpr_types.h'\fP
.br
\fC#include 'mca/soh/soh_types.h'\fP
.br
\fC#include 'rmgr_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBORTE_RMGR_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in components that are of type rmgr v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_query_fn_t\fP )(void)"
.br
.RI "\fIQuery/update a resource. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_create_fn_t\fP )(\fBorte_app_context_t\fP **app_context, size_t num_context, \fBorte_jobid_t\fP *jobid)"
.br
.RI "\fICreate a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_allocate_fn_t\fP )(\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIAllocate resources to a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_deallocate_fn_t\fP )(\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIDeallocate resources from a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_map_fn_t\fP )(\fBorte_jobid_t\fP job)"
.br
.RI "\fIMap processes to resources assigned to a job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_launch_fn_t\fP )(\fBorte_jobid_t\fP job)"
.br
.RI "\fILaunch processes that have been mapped. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_terminate_job_fn_t\fP )(\fBorte_jobid_t\fP job)"
.br
.RI "\fITerminate an entire job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_terminate_proc_fn_t\fP )(const orte_process_name_t *proc_name)"
.br
.RI "\fITerminate a specific process. \fP"
.ti -1c
.RI "typedef void(* \fBorte_rmgr_cb_fn_t\fP )(\fBorte_jobid_t\fP jobid, orte_proc_state_t state)"
.br
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_spawn_fn_t\fP )(\fBorte_app_context_t\fP **app_context, size_t num_context, \fBorte_jobid_t\fP *jobid, orte_rmgr_cb_fn_t cbfn)"
.br
.RI "\fIShortcut to spawn an applications. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_proc_stage_gate_init_fn_t\fP )(\fBorte_jobid_t\fP job)"
.br
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_proc_stage_gate_mgr_fn_t\fP )(orte_gpr_notify_message_t *msg)"
.br
.ti -1c
.RI "typedef int(* \fBorte_rmgr_base_module_finalize_fn_t\fP )(void)"
.br
.RI "\fICleanup resources held by rmgr. \fP"
.ti -1c
.RI "typedef orte_rmgr_base_module_1_0_0_t \fBorte_rmgr_base_module_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef orte_rmgr_base_module_1_0_0_t \fBorte_rmgr_base_module_t\fP"
.br
.ti -1c
.RI "typedef orte_rmgr_base_module_t *(* \fBorte_rmgr_base_component_init_fn_t\fP )(int *priority)"
.br
.ti -1c
.RI "typedef orte_rmgr_base_component_1_0_0_t \fBorte_rmgr_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef orte_rmgr_base_component_1_0_0_t \fBorte_rmgr_base_component_t\fP"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC orte_rmgr_base_module_t \fBorte_rmgr\fP"
.br
.RI "\fIGlobal structure for accessing RAS functions. \fP"
.in -1c
.SH "Detailed Description"
.PP 
The Open RTE Resource Manager (RMGR) Subsystem. 

The resource manager (RMGR) subsystem serves as the central switchyard for all resource management activities, including resource discovery, resource allocation, process mapping, and process launch.
.SH "Define Documentation"
.PP 
.SS "#define ORTE_RMGR_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* rmgr v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* rmgr v1.0 */ \
  'rmgr', 1, 0, 0
.fi
Macro for use in components that are of type rmgr v1.0.0. 
.PP
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBorte_rmgr_base_module_allocate_fn_t\fP)(\fBorte_jobid_t\fP jobid)"
.PP
Allocate resources to a job. 
.PP
.PP
.nf
 return_value = orte_rmgr.allocate(orte_jobid_t jobid)
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_create_fn_t\fP)(\fBorte_app_context_t\fP **app_context, size_t num_context, \fBorte_jobid_t\fP *jobid)"
.PP
Create a job. 
.PP
Allocated a jobid and initializes the job segment.
.PP
\fBParameters:\fP
.RS 4
\fIapp_context\fP Array of application context values. 
.br
\fInum_context\fP Number of entries in the app_context array. 
.br
\fIjobid\fP Returns id allocated to the job.
.RE
.PP
.PP
.nf
 orte_jobid_t jobid;

 return_value = orte_rmgr.create(app_context,num_context,&jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_deallocate_fn_t\fP)(\fBorte_jobid_t\fP jobid)"
.PP
Deallocate resources from a job. 
.PP
.PP
.nf
 return_value = orte_rmgr.deallocate(orte_jobid_t jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_launch_fn_t\fP)(\fBorte_jobid_t\fP job)"
.PP
Launch processes that have been mapped. 
.PP
.PP
.nf
 return_value = orte_rmgr.launch(orte_jobid_t jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_map_fn_t\fP)(\fBorte_jobid_t\fP job)"
.PP
Map processes to resources assigned to a job. 
.PP
.PP
.nf
 return_value = orte_mgr.map(orte_jobid_t jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_query_fn_t\fP)(void)"
.PP
Query/update a resource. 
.PP
.PP
.nf
 return_value = orte_rmgr.query();
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_spawn_fn_t\fP)(\fBorte_app_context_t\fP **app_context, size_t num_context, \fBorte_jobid_t\fP *jobid, orte_rmgr_cb_fn_t cbfn)"
.PP
Shortcut to spawn an applications. 
.PP
Perform all steps required to launch the specified application.
.PP
(1) Create the application context - create a jobid (2) Allocated resources to the job. (3) Map processes to allocated resources (4) Launch the job. (5) Callback function - gets called when job completes (if NULL, then no callback done)
.PP
.PP
.nf
 orte_jobid_t jobid;

 return_value = orte_rmgr.spawn(app_context, num_context, &jobid, NULL);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_terminate_job_fn_t\fP)(\fBorte_jobid_t\fP job)"
.PP
Terminate an entire job. 
.PP
.PP
.nf
 return_value = orte_rmgr.terminate_job(orte_jobid_t jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_rmgr_base_module_terminate_proc_fn_t\fP)(const orte_process_name_t *proc_name)"
.PP
Terminate a specific process. 
.PP
.PP
.nf
 return_value = orte_rmgr.terminate_proc(const orte_process_name_t* proc_name);
.fi
.PP
 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
